diff --git a/gcc/rust/resolve/rust-ast-resolve-expr.cc b/gcc/rust/resolve/rust-ast-resolve-expr.cc
index 8ece5b63b6d..293c63f5628 100644
--- a/gcc/rust/resolve/rust-ast-resolve-expr.cc
+++ b/gcc/rust/resolve/rust-ast-resolve-expr.cc
@@ -209,7 +209,7 @@ ResolveExpr::visit (AST::IfLetExpr &expr)
 
   for (auto &pattern : expr.get_patterns ())
     {
-      PatternDeclaration::go (pattern.get ());
+      PatternDeclaration::go (pattern.get (), Rib::ItemType::Var);
     }
 
   ResolveExpr::go (expr.get_if_block ().get (), prefix, canonical_prefix);
@@ -343,7 +343,7 @@ ResolveExpr::visit (AST::LoopExpr &expr)
       auto label_lifetime_node_id = label.get_lifetime ().get_node_id ();
       resolver->get_label_scope ().insert (
 	CanonicalPath::new_seg (expr.get_node_id (), label_name),
-	label_lifetime_node_id, label.get_locus (), false,
+	label_lifetime_node_id, label.get_locus (), false, Rib::ItemType::Label,
 	[&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	  rust_error_at (label.get_locus (), "label redefined multiple times");
 	  rust_error_at (locus, "was defined here");
@@ -400,7 +400,7 @@ ResolveExpr::visit (AST::WhileLoopExpr &expr)
       auto label_lifetime_node_id = label.get_lifetime ().get_node_id ();
       resolver->get_label_scope ().insert (
 	CanonicalPath::new_seg (label.get_node_id (), label_name),
-	label_lifetime_node_id, label.get_locus (), false,
+	label_lifetime_node_id, label.get_locus (), false, Rib::ItemType::Label,
 	[&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	  rust_error_at (label.get_locus (), "label redefined multiple times");
 	  rust_error_at (locus, "was defined here");
@@ -429,7 +429,7 @@ ResolveExpr::visit (AST::ForLoopExpr &expr)
       auto label_lifetime_node_id = label.get_lifetime ().get_node_id ();
       resolver->get_label_scope ().insert (
 	CanonicalPath::new_seg (label.get_node_id (), label_name),
-	label_lifetime_node_id, label.get_locus (), false,
+	label_lifetime_node_id, label.get_locus (), false, Rib::ItemType::Label,
 	[&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	  rust_error_at (label.get_locus (), "label redefined multiple times");
 	  rust_error_at (locus, "was defined here");
@@ -446,7 +446,7 @@ ResolveExpr::visit (AST::ForLoopExpr &expr)
   resolver->push_new_label_rib (resolver->get_type_scope ().peek ());
 
   // resolve the expression
-  PatternDeclaration::go (expr.get_pattern ().get ());
+  PatternDeclaration::go (expr.get_pattern ().get (), Rib::ItemType::Var);
   ResolveExpr::go (expr.get_iterator_expr ().get (), prefix, canonical_prefix);
   ResolveExpr::go (expr.get_loop_block ().get (), prefix, canonical_prefix);
 
@@ -520,7 +520,7 @@ ResolveExpr::visit (AST::MatchExpr &expr)
       // insert any possible new patterns
       for (auto &pattern : arm.get_patterns ())
 	{
-	  PatternDeclaration::go (pattern.get ());
+	  PatternDeclaration::go (pattern.get (), Rib::ItemType::Var);
 	}
 
       // resolve the body
@@ -617,7 +617,7 @@ ResolveExpr::visit (AST::ClosureExprInnerTyped &expr)
 void
 ResolveExpr::resolve_closure_param (AST::ClosureParam &param)
 {
-  PatternDeclaration::go (param.get_pattern ().get ());
+  PatternDeclaration::go (param.get_pattern ().get (), Rib::ItemType::Param);
 
   if (param.has_type_given ())
     ResolveType::go (param.get_type ().get ());
diff --git a/gcc/rust/resolve/rust-ast-resolve-implitem.h b/gcc/rust/resolve/rust-ast-resolve-implitem.h
index 52e025672bd..9cad8aa41a5 100644
--- a/gcc/rust/resolve/rust-ast-resolve-implitem.h
+++ b/gcc/rust/resolve/rust-ast-resolve-implitem.h
@@ -56,7 +56,7 @@ public:
     auto path = prefix.append (decl);
 
     resolver->get_type_scope ().insert (
-      path, type.get_node_id (), type.get_locus (), false,
+      path, type.get_node_id (), type.get_locus (), false, Rib::ItemType::Type,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (type.get_locus ());
 	r.add_range (locus);
@@ -72,6 +72,7 @@ public:
 
     resolver->get_name_scope ().insert (
       path, constant.get_node_id (), constant.get_locus (), false,
+      Rib::ItemType::Const,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (constant.get_locus ());
 	r.add_range (locus);
@@ -87,6 +88,7 @@ public:
 
     resolver->get_name_scope ().insert (
       path, function.get_node_id (), function.get_locus (), false,
+      Rib::ItemType::Function,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (function.get_locus ());
 	r.add_range (locus);
@@ -102,6 +104,7 @@ public:
 
     resolver->get_name_scope ().insert (
       path, method.get_node_id (), method.get_locus (), false,
+      Rib::ItemType::Function,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (method.get_locus ());
 	r.add_range (locus);
@@ -141,6 +144,7 @@ public:
 
     resolver->get_name_scope ().insert (
       path, function.get_node_id (), function.get_locus (), false,
+      Rib::ItemType::Function,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (function.get_locus ());
 	r.add_range (locus);
@@ -159,6 +163,7 @@ public:
 
     resolver->get_name_scope ().insert (
       path, method.get_node_id (), method.get_locus (), false,
+      Rib::ItemType::Function,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (method.get_locus ());
 	r.add_range (locus);
@@ -177,6 +182,7 @@ public:
 
     resolver->get_name_scope ().insert (
       path, constant.get_node_id (), constant.get_locus (), false,
+      Rib::ItemType::Const,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (constant.get_locus ());
 	r.add_range (locus);
@@ -194,7 +200,7 @@ public:
     auto cpath = canonical_prefix.append (decl);
 
     resolver->get_type_scope ().insert (
-      path, type.get_node_id (), type.get_locus (), false,
+      path, type.get_node_id (), type.get_locus (), false, Rib::ItemType::Type,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (type.get_locus ());
 	r.add_range (locus);
@@ -233,6 +239,7 @@ public:
 
     resolver->get_name_scope ().insert (
       path, function.get_node_id (), function.get_locus (), false,
+      Rib::ItemType::Function,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (function.get_locus ());
 	r.add_range (locus);
@@ -251,6 +258,7 @@ public:
 
     resolver->get_name_scope ().insert (
       path, item.get_node_id (), item.get_locus (), false,
+      Rib::ItemType::Static,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (item.get_locus ());
 	r.add_range (locus);
diff --git a/gcc/rust/resolve/rust-ast-resolve-item.cc b/gcc/rust/resolve/rust-ast-resolve-item.cc
index 193e6834334..0be9a02a6f6 100644
--- a/gcc/rust/resolve/rust-ast-resolve-item.cc
+++ b/gcc/rust/resolve/rust-ast-resolve-item.cc
@@ -82,7 +82,8 @@ ResolveTraitItems::visit (AST::TraitItemFunc &func)
   for (auto &param : function.get_function_params ())
     {
       ResolveType::go (param.get_type ().get ());
-      PatternDeclaration::go (param.get_pattern ().get ());
+      PatternDeclaration::go (param.get_pattern ().get (),
+			      Rib::ItemType::Param);
     }
 
   if (function.has_where_clause ())
@@ -138,14 +139,15 @@ ResolveTraitItems::visit (AST::TraitItemMethod &func)
   AST::TypePath self_type_path (std::move (segments), self_param.get_locus ());
 
   ResolveType::go (&self_type_path);
-  PatternDeclaration::go (&self_pattern);
+  PatternDeclaration::go (&self_pattern, Rib::ItemType::Param);
 
   // we make a new scope so the names of parameters are resolved and shadowed
   // correctly
   for (auto &param : function.get_function_params ())
     {
       ResolveType::go (param.get_type ().get ());
-      PatternDeclaration::go (param.get_pattern ().get ());
+      PatternDeclaration::go (param.get_pattern ().get (),
+			      Rib::ItemType::Param);
     }
 
   if (function.has_where_clause ())
@@ -499,10 +501,8 @@ ResolveItem::visit (AST::Function &function)
   for (auto &param : function.get_function_params ())
     {
       ResolveType::go (param.get_type ().get ());
-      PatternDeclaration::go (param.get_pattern ().get ());
-
-      // the mutability checker needs to verify for immutable decls the number
-      // of assignments are <1. This marks an implicit assignment
+      PatternDeclaration::go (param.get_pattern ().get (),
+			      Rib::ItemType::Param);
     }
 
   // resolve the function body
@@ -631,14 +631,15 @@ ResolveItem::visit (AST::Method &method)
   AST::TypePath self_type_path (std::move (segments), self_param.get_locus ());
 
   ResolveType::go (&self_type_path);
-  PatternDeclaration::go (&self_pattern);
+  PatternDeclaration::go (&self_pattern, Rib::ItemType::Param);
 
   // we make a new scope so the names of parameters are resolved and shadowed
   // correctly
   for (auto &param : method.get_function_params ())
     {
       ResolveType::go (param.get_type ().get ());
-      PatternDeclaration::go (param.get_pattern ().get ());
+      PatternDeclaration::go (param.get_pattern ().get (),
+			      Rib::ItemType::Param);
     }
 
   // resolve any where clause items
diff --git a/gcc/rust/resolve/rust-ast-resolve-pattern.cc b/gcc/rust/resolve/rust-ast-resolve-pattern.cc
index 483d1908822..10f4fd8a61b 100644
--- a/gcc/rust/resolve/rust-ast-resolve-pattern.cc
+++ b/gcc/rust/resolve/rust-ast-resolve-pattern.cc
@@ -49,7 +49,7 @@ PatternDeclaration::visit (AST::TupleStructPattern &pattern)
 
 	for (auto &inner_pattern : items_no_range.get_patterns ())
 	  {
-	    PatternDeclaration::go (inner_pattern.get ());
+	    PatternDeclaration::go (inner_pattern.get (), type);
 	  }
       }
       break;
diff --git a/gcc/rust/resolve/rust-ast-resolve-pattern.h b/gcc/rust/resolve/rust-ast-resolve-pattern.h
index ea99c63b1ca..5f2b7293cf2 100644
--- a/gcc/rust/resolve/rust-ast-resolve-pattern.h
+++ b/gcc/rust/resolve/rust-ast-resolve-pattern.h
@@ -55,9 +55,9 @@ class PatternDeclaration : public ResolverBase
   using Rust::Resolver::ResolverBase::visit;
 
 public:
-  static void go (AST::Pattern *pattern)
+  static void go (AST::Pattern *pattern, Rib::ItemType type)
   {
-    PatternDeclaration resolver;
+    PatternDeclaration resolver (type);
     pattern->accept_vis (resolver);
   };
 
@@ -67,14 +67,14 @@ public:
     // as new refs to this decl will match back here so it is ok to overwrite
     resolver->get_name_scope ().insert (
       CanonicalPath::new_seg (pattern.get_node_id (), pattern.get_ident ()),
-      pattern.get_node_id (), pattern.get_locus ());
+      pattern.get_node_id (), pattern.get_locus (), type);
   }
 
   void visit (AST::WildcardPattern &pattern) override
   {
     resolver->get_name_scope ().insert (
       CanonicalPath::new_seg (pattern.get_node_id (), "_"),
-      pattern.get_node_id (), pattern.get_locus ());
+      pattern.get_node_id (), pattern.get_locus (), type);
   }
 
   // cases in a match expression
@@ -89,7 +89,9 @@ public:
   void visit (AST::RangePattern &pattern) override;
 
 private:
-  PatternDeclaration () : ResolverBase () {}
+  PatternDeclaration (Rib::ItemType type) : ResolverBase (), type (type) {}
+
+  Rib::ItemType type;
 };
 
 } // namespace Resolver
diff --git a/gcc/rust/resolve/rust-ast-resolve-stmt.h b/gcc/rust/resolve/rust-ast-resolve-stmt.h
index be93b008996..28c547f410b 100644
--- a/gcc/rust/resolve/rust-ast-resolve-stmt.h
+++ b/gcc/rust/resolve/rust-ast-resolve-stmt.h
@@ -64,6 +64,7 @@ public:
 
     resolver->get_name_scope ().insert (
       path, constant.get_node_id (), constant.get_locus (), false,
+      Rib::ItemType::Const,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (constant.get_locus ());
 	r.add_range (locus);
@@ -82,7 +83,7 @@ public:
 			 canonical_prefix);
       }
 
-    PatternDeclaration::go (stmt.get_pattern ().get ());
+    PatternDeclaration::go (stmt.get_pattern ().get (), Rib::ItemType::Var);
     if (stmt.has_type ())
       ResolveType::go (stmt.get_type ().get ());
   }
@@ -97,6 +98,7 @@ public:
 
     resolver->get_type_scope ().insert (
       path, struct_decl.get_node_id (), struct_decl.get_locus (), false,
+      Rib::ItemType::Type,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (struct_decl.get_locus ());
 	r.add_range (locus);
@@ -128,6 +130,7 @@ public:
 
     resolver->get_type_scope ().insert (
       path, enum_decl.get_node_id (), enum_decl.get_locus (), false,
+      Rib::ItemType::Type,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (enum_decl.get_locus ());
 	r.add_range (locus);
@@ -158,7 +161,7 @@ public:
     mappings->insert_canonical_path (item.get_node_id (), cpath);
 
     resolver->get_type_scope ().insert (
-      path, item.get_node_id (), item.get_locus (), false,
+      path, item.get_node_id (), item.get_locus (), false, Rib::ItemType::Type,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (item.get_locus ());
 	r.add_range (locus);
@@ -177,7 +180,7 @@ public:
     mappings->insert_canonical_path (item.get_node_id (), cpath);
 
     resolver->get_type_scope ().insert (
-      path, item.get_node_id (), item.get_locus (), false,
+      path, item.get_node_id (), item.get_locus (), false, Rib::ItemType::Type,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (item.get_locus ());
 	r.add_range (locus);
@@ -202,7 +205,7 @@ public:
     mappings->insert_canonical_path (item.get_node_id (), cpath);
 
     resolver->get_type_scope ().insert (
-      path, item.get_node_id (), item.get_locus (), false,
+      path, item.get_node_id (), item.get_locus (), false, Rib::ItemType::Type,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (item.get_locus ());
 	r.add_range (locus);
@@ -227,7 +230,7 @@ public:
     mappings->insert_canonical_path (item.get_node_id (), cpath);
 
     resolver->get_type_scope ().insert (
-      path, item.get_node_id (), item.get_locus (), false,
+      path, item.get_node_id (), item.get_locus (), false, Rib::ItemType::Type,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (item.get_locus ());
 	r.add_range (locus);
@@ -247,6 +250,7 @@ public:
 
     resolver->get_type_scope ().insert (
       path, struct_decl.get_node_id (), struct_decl.get_locus (), false,
+      Rib::ItemType::Type,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (struct_decl.get_locus ());
 	r.add_range (locus);
@@ -283,6 +287,7 @@ public:
 
     resolver->get_type_scope ().insert (
       path, union_decl.get_node_id (), union_decl.get_locus (), false,
+      Rib::ItemType::Type,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (union_decl.get_locus ());
 	r.add_range (locus);
@@ -317,6 +322,7 @@ public:
 
     resolver->get_name_scope ().insert (
       path, function.get_node_id (), function.get_locus (), false,
+      Rib::ItemType::Function,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (function.get_locus ());
 	r.add_range (locus);
@@ -343,7 +349,8 @@ public:
     for (auto &param : function.get_function_params ())
       {
 	ResolveType::go (param.get_type ().get ());
-	PatternDeclaration::go (param.get_pattern ().get ());
+	PatternDeclaration::go (param.get_pattern ().get (),
+				Rib::ItemType::Param);
       }
 
     // resolve the function body
diff --git a/gcc/rust/resolve/rust-ast-resolve-toplevel.h b/gcc/rust/resolve/rust-ast-resolve-toplevel.h
index 4cc51011777..d751318ee54 100644
--- a/gcc/rust/resolve/rust-ast-resolve-toplevel.h
+++ b/gcc/rust/resolve/rust-ast-resolve-toplevel.h
@@ -57,6 +57,7 @@ public:
 
     resolver->get_name_scope ().insert (
       path, module.get_node_id (), module.get_locus (), false,
+      Rib::ItemType::Module,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (module.get_locus ());
 	r.add_range (locus);
@@ -85,6 +86,7 @@ public:
 
     resolver->get_type_scope ().insert (
       path, alias.get_node_id (), alias.get_locus (), false,
+      Rib::ItemType::Type,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (alias.get_locus ());
 	r.add_range (locus);
@@ -105,6 +107,7 @@ public:
 
     resolver->get_type_scope ().insert (
       path, struct_decl.get_node_id (), struct_decl.get_locus (), false,
+      Rib::ItemType::Type,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (struct_decl.get_locus ());
 	r.add_range (locus);
@@ -125,6 +128,7 @@ public:
 
     resolver->get_type_scope ().insert (
       path, enum_decl.get_node_id (), enum_decl.get_locus (), false,
+      Rib::ItemType::Type,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (enum_decl.get_locus ());
 	r.add_range (locus);
@@ -147,7 +151,7 @@ public:
     auto cpath = canonical_prefix.append (decl);
 
     resolver->get_type_scope ().insert (
-      path, item.get_node_id (), item.get_locus (), false,
+      path, item.get_node_id (), item.get_locus (), false, Rib::ItemType::Type,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (item.get_locus ());
 	r.add_range (locus);
@@ -165,7 +169,7 @@ public:
     auto cpath = canonical_prefix.append (decl);
 
     resolver->get_type_scope ().insert (
-      path, item.get_node_id (), item.get_locus (), false,
+      path, item.get_node_id (), item.get_locus (), false, Rib::ItemType::Type,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (item.get_locus ());
 	r.add_range (locus);
@@ -183,7 +187,7 @@ public:
     auto cpath = canonical_prefix.append (decl);
 
     resolver->get_type_scope ().insert (
-      path, item.get_node_id (), item.get_locus (), false,
+      path, item.get_node_id (), item.get_locus (), false, Rib::ItemType::Type,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (item.get_locus ());
 	r.add_range (locus);
@@ -201,7 +205,7 @@ public:
     auto cpath = canonical_prefix.append (decl);
 
     resolver->get_type_scope ().insert (
-      path, item.get_node_id (), item.get_locus (), false,
+      path, item.get_node_id (), item.get_locus (), false, Rib::ItemType::Type,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (item.get_locus ());
 	r.add_range (locus);
@@ -220,6 +224,7 @@ public:
 
     resolver->get_type_scope ().insert (
       path, struct_decl.get_node_id (), struct_decl.get_locus (), false,
+      Rib::ItemType::Type,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (struct_decl.get_locus ());
 	r.add_range (locus);
@@ -240,6 +245,7 @@ public:
 
     resolver->get_type_scope ().insert (
       path, union_decl.get_node_id (), union_decl.get_locus (), false,
+      Rib::ItemType::Type,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (union_decl.get_locus ());
 	r.add_range (locus);
@@ -259,7 +265,7 @@ public:
     auto cpath = canonical_prefix.append (decl);
 
     resolver->get_name_scope ().insert (
-      path, var.get_node_id (), var.get_locus (), false,
+      path, var.get_node_id (), var.get_locus (), false, Rib::ItemType::Static,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (var.get_locus ());
 	r.add_range (locus);
@@ -280,6 +286,7 @@ public:
 
     resolver->get_name_scope ().insert (
       path, constant.get_node_id (), constant.get_locus (), false,
+      Rib::ItemType::Const,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (constant.get_locus ());
 	r.add_range (locus);
@@ -300,6 +307,7 @@ public:
 
     resolver->get_name_scope ().insert (
       path, function.get_node_id (), function.get_locus (), false,
+      Rib::ItemType::Function,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (function.get_locus ());
 	r.add_range (locus);
@@ -343,6 +351,7 @@ public:
 
     resolver->get_name_scope ().insert (
       impl_prefix, impl_block.get_node_id (), impl_block.get_locus (), false,
+      Rib::ItemType::TraitImpl,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (impl_block.get_locus ());
 	r.add_range (locus);
@@ -362,6 +371,7 @@ public:
 
     resolver->get_type_scope ().insert (
       path, trait.get_node_id (), trait.get_locus (), false,
+      Rib::ItemType::Trait,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (trait.get_locus ());
 	r.add_range (locus);
@@ -437,6 +447,7 @@ public:
 
     resolver->get_type_scope ().insert (
       decl, resolved_crate, extern_crate.get_locus (), false,
+      Rib::ItemType::ExternCrate,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	RichLocation r (extern_crate.get_locus ());
 	r.add_range (locus);
diff --git a/gcc/rust/resolve/rust-ast-resolve-type.h b/gcc/rust/resolve/rust-ast-resolve-type.h
index 424233fa3df..bb1178362fb 100644
--- a/gcc/rust/resolve/rust-ast-resolve-type.h
+++ b/gcc/rust/resolve/rust-ast-resolve-type.h
@@ -177,7 +177,7 @@ public:
     auto seg = CanonicalPath::new_seg (param.get_node_id (),
 				       param.get_type_representation ());
     resolver->get_type_scope ().insert (
-      seg, param.get_node_id (), param.get_locus (), false,
+      seg, param.get_node_id (), param.get_locus (), false, Rib::ItemType::Type,
       [&] (const CanonicalPath &, NodeId, Location locus) -> void {
 	rust_error_at (param.get_locus (),
 		       "generic param redefined multiple times");
diff --git a/gcc/rust/resolve/rust-name-resolver.cc b/gcc/rust/resolve/rust-name-resolver.cc
index cc1ec2b9dc7..cf3028ef271 100644
--- a/gcc/rust/resolve/rust-name-resolver.cc
+++ b/gcc/rust/resolve/rust-name-resolver.cc
@@ -29,7 +29,7 @@ Rib::Rib (CrateNum crateNum, NodeId node_id)
 void
 Rib::insert_name (
   const CanonicalPath &path, NodeId id, Location locus, bool shadow,
-
+  ItemType type,
   std::function<void (const CanonicalPath &, NodeId, Location)> dup_cb)
 {
   auto it = path_mappings.find (path);
@@ -49,6 +49,7 @@ Rib::insert_name (
   reverse_path_mappings.insert ({id, path});
   decls_within_rib.insert ({id, locus});
   references[id] = {};
+  decl_type_mappings.insert ({id, type});
 }
 
 bool
@@ -105,6 +106,17 @@ Rib::decl_was_declared_here (NodeId def) const
   return false;
 }
 
+bool
+Rib::lookup_decl_type (NodeId def, ItemType *type) const
+{
+  auto it = decl_type_mappings.find (def);
+  if (it == decl_type_mappings.end ())
+    return false;
+
+  *type = it->second;
+  return true;
+}
+
 void
 Rib::debug () const
 {
@@ -128,15 +140,17 @@ Scope::Scope (CrateNum crate_num) : crate_num (crate_num) {}
 void
 Scope::insert (
   const CanonicalPath &ident, NodeId id, Location locus, bool shadow,
+  Rib::ItemType type,
   std::function<void (const CanonicalPath &, NodeId, Location)> dup_cb)
 {
-  peek ()->insert_name (ident, id, locus, shadow, dup_cb);
+  peek ()->insert_name (ident, id, locus, shadow, type, dup_cb);
 }
 
 void
-Scope::insert (const CanonicalPath &ident, NodeId id, Location locus)
+Scope::insert (const CanonicalPath &ident, NodeId id, Location locus,
+	       Rib::ItemType type)
 {
-  peek ()->insert_name (ident, id, locus, true,
+  peek ()->insert_name (ident, id, locus, true, type,
 			[] (const CanonicalPath &, NodeId, Location) -> void {
 			});
 }
@@ -321,6 +335,7 @@ Resolver::insert_builtin_types (Rib *r)
 				  builtin->as_string ());
       r->insert_name (builtin_path, builtin->get_node_id (),
 		      Linemap::predeclared_location (), false,
+		      Rib::ItemType::Type,
 		      [] (const CanonicalPath &, NodeId, Location) -> void {});
     }
 }
diff --git a/gcc/rust/resolve/rust-name-resolver.h b/gcc/rust/resolve/rust-name-resolver.h
index d2f740e0315..54d59544b1d 100644
--- a/gcc/rust/resolve/rust-name-resolver.h
+++ b/gcc/rust/resolve/rust-name-resolver.h
@@ -30,6 +30,24 @@ namespace Resolver {
 class Rib
 {
 public:
+  enum ItemType
+  {
+    Var,
+    Param,
+    Function,
+    Type,
+    Module,
+    Static,
+    Const,
+    Trait,
+    Impl,
+    TraitImpl,
+    ExternCrate,
+    MacroDecl,
+    Label,
+    Unknown
+  };
+
   // FIXME
   // Rust uses local_def_ids assigned by def_collector on the AST. Consider
   // moving to a local-def-id
@@ -38,6 +56,7 @@ public:
   // this takes the relative paths of items within a compilation unit for lookup
   void insert_name (
     const CanonicalPath &path, NodeId id, Location locus, bool shadow,
+    ItemType type,
     std::function<void (const CanonicalPath &, NodeId, Location)> dup_cb);
 
   bool lookup_canonical_path (const NodeId &id, CanonicalPath *ident);
@@ -46,6 +65,7 @@ public:
   void append_reference_for_def (NodeId def, NodeId ref);
   bool have_references_for_node (NodeId def) const;
   bool decl_was_declared_here (NodeId def) const;
+  bool lookup_decl_type (NodeId def, ItemType *type) const;
   void debug () const;
   std::string debug_str () const;
 
@@ -60,6 +80,7 @@ private:
   std::map<NodeId, CanonicalPath> reverse_path_mappings;
   std::map<NodeId, Location> decls_within_rib;
   std::map<NodeId, std::set<NodeId>> references;
+  std::map<NodeId, ItemType> decl_type_mappings;
 };
 
 class Scope
@@ -69,9 +90,11 @@ public:
 
   void
   insert (const CanonicalPath &ident, NodeId id, Location locus, bool shadow,
+	  Rib::ItemType type,
 	  std::function<void (const CanonicalPath &, NodeId, Location)> dup_cb);
 
-  void insert (const CanonicalPath &ident, NodeId id, Location locus);
+  void insert (const CanonicalPath &ident, NodeId id, Location locus,
+	       Rib::ItemType type = Rib::ItemType::Unknown);
   bool lookup (const CanonicalPath &ident, NodeId *id);
 
   void iterate (std::function<bool (Rib *)> cb);